Fireface {
	var <inputScheme, <outputScheme, <destinations, <inputs;
	*new { ^super.new.init }
	init {
		inputScheme = Dictionary(28*2);
		10.do({ arg i;
			var sym;
			sym = 'analog_' +++ (i+1);
			inputScheme.add( sym -> i);
			inputScheme.add( i -> sym );
		});
		2.do({ arg i;
			var sym;
			sym = 'spdif_' +++ (i+1);
			inputScheme.add( sym -> (i+10));
			inputScheme.add( (i+10) -> sym );
		});
		2.do({ arg j;
			8.do({ arg i;
				var sym;
				sym = 'adat' +++ (j+1) +++ '_' +++ (i+1);
				inputScheme.add( sym -> (j*8+i+12));
				inputScheme.add( (j*8+i+12) -> sym );
			});
		});
		
		// gives names to output busses
		outputScheme = Dictionary(28*2);
		8.do({ arg i;
			var sym;
			sym ='analog_' +++ (i+1);
			outputScheme.add( sym -> i);
			outputScheme.add( i -> sym);
		});
		2.do({ arg i;
			var sym;
			sym =  'headphone_' +++ (i+1);
			outputScheme.add( sym -> (i+8));
			outputScheme.add( (i+8) -> sym);
		});
		2.do({ arg i;
			var sym;
			sym =  'spdif_' +++ (i+1);
			outputScheme.add( sym -> (i+10) );
			outputScheme.add( (i+10) -> sym );
		});
		2.do({ arg j;
			8.do({ arg i;
				var sym;
				sym = 'adat' +++ (j+1) +++ '_' +++ (i+1);
				outputScheme.add( sym -> (j*8+i+12));
				outputScheme.add( (j*8+i+12) -> sym );
			});
		});
		destinations = Dictionary(28*2);
		inputs = Dictionary(28*2);
	}
	setDestination { arg outputbus, device; var x;
		x = outputScheme[outputbus] ? outputScheme[outputbus];
		destinations[device] = x;
		destinations[x] = device;
		^device->x;
	}
	setSpecialDestination { arg outputbus, device; var x;
		destinations[device] = outputbus;
		destinations[outputbus] = device;
		^device->x;
	}
	setInput { arg inputbus, device; var x;
		x = inputScheme[inputbus];
		inputs[device] = x;
		inputs[x] = device;
		^device->x;
	}
	getOutBus { arg name;
		^outputScheme[name];
	}
	getDestOutBus { arg dest;
		^destinations[dest];
	}
	getInputBus { arg in;
		^inputs[in];
	}
	getInBus { arg name;
		^inputScheme[name];
	}
	getOutBusName { arg bus;
		^outputScheme[bus];
	}
	getInBusName { arg bus;
		^inputScheme[bus];
	}
	inputsKeys {
		^this.getKeys(inputs).collect({ arg bus; inputs[bus] });
	}
	destsKeys {
		^this.getKeys(destinations).collect({ arg bus; destinations[bus] });
	}
	destsBusses {
		^this.getKeys(destinations).collect({ arg bus; destinations[bus] });
	}
	getKeys { arg array;
		array = array.keys.asArray.sort({ arg a, b; (a.isInteger && b.isInteger).if({a<b}, {a.asString < b.asString}) });
		^array.copyRange(0, array.size div: 2 - 1 );
	}
	inputsDo { arg fn;
		this.inputsKeys.do({ arg bus, i; var x;
			x = inputs[bus];
			fn.value(x, bus, i);
		});
	}
	destsDo { arg fn;
		this.destsKeys.do({ arg bus, i; var x;
			x = destinations[bus];
			fn.value(x, bus, i);
		});
	}
}