

MyVocoder {

//plain vocoder
        *ar {arg signal, input, minFreq, maxFreq, bandNumb, bandWidth = 1, mull = 10;

                var freqIncr, sourceAmp, freqArray;

                freqIncr = (maxFreq-minFreq)/bandNumb;
                freqArray = Array.series(bandNumb, minFreq, freqIncr);
                sourceAmp = Amplitude.kr(input);
                ^Mix.arFill ( freqArray.size, {arg i;
                        var output, freq;
                        freq = freqArray.at(i);
                        output = BPF.ar(signal, freqArray.at(i), bandWidth/freq,sourceAmp)*mull
                })
        }

//plain vocoder, takes an array of freqs
        *ar3 {arg signal, input, array, bandWidth = 1, mull = 10;

                var sourceAmp, freqArray;

                freqArray = array;
                sourceAmp = Amplitude.kr(input);
                ^Mix.arFill ( freqArray.size, {arg i;
                        var output, freq;
                        freq = freqArray.at(i);
                        output = BPF.ar(signal, freqArray.at(i), bandWidth/freq,sourceAmp)*mull
                })
        }

//vocoder with fixed bands... supposedly very accurate?  Freqs from Juan Pampin.
        *ar5 {arg signal, input, mull = 10;

                var sourceAmp, freqArray, bwArray;

                freqArray = [50, 150, 250, 350, 450, 570, 700, 840, 1000,
						1170, 1370, 1600, 1850,
                			2150, 2500, 2900, 3400, 4000,
						4800, 5800, 7000, 8500, 10500, 13500];
                sourceAmp = Amplitude.kr(input);
                bwArray =
						[50,50,50,50,60,70,80,80,100,110,130,150,180,200,250,400,500,600,700,
                			1000,1500,2000,3500,3500];
                ^Mix.arFill ( freqArray.size, {arg i;
                        var output, freq, bandWidth;
                        freq = freqArray.at(i);
                        bandWidth = bwArray.at(i);
                        output = BPF.ar(signal, freqArray.at(i),bandWidth/freq, sourceAmp)*mull
                })
        }



// vocoder with tracking on each band
        *ar1 {arg signal, input, minFreq, maxFreq, bandNumb, bandWidth = 1, mull = 1000;

                var freqIncr, freqArray;

                freqIncr = (maxFreq-minFreq)/bandNumb;
                freqArray = Array.series(bandNumb, minFreq, freqIncr);
                ^Mix.fill ( freqArray.size, {arg i;
                        var source, sourceAmp, output, freq;
                        freq = freqArray.at(i);
                        source = BPF.ar(input,freqArray.at(i),bandWidth/freq);
                        sourceAmp = Amplitude.kr(source);
                        output = BPF.ar(signal, freqArray.at(i), bandWidth/freq,sourceAmp)*mull
                })
        }

// vocoder with combfilters tracking on each band
        *ar2 { arg signal, input, minFreq, maxFreq, bandNumb, bandWidth = 1, mull = 1;

                var freqIncr, freqArray;

                freqIncr = (maxFreq-minFreq)/bandNumb;
                freqArray = Array.series(bandNumb, minFreq, freqIncr);
                ^Mix.arFill ( freqArray.size, {arg i;
                        var source, sourceAmp, output, freq;
                        freq = freqArray.at(i);
                        source = BPF.ar(input, freqArray.at(i),bandWidth/freq);
                        sourceAmp = Amplitude.kr(source);
                        output = CombN.ar(signal, 0.1, 1/freqArray.at(i),0.999,sourceAmp)*mull
                })
        }

// vocoder with combfilters, take array of freqs
        *ar4 { arg signal, input, array, bandWidth = 1, mull = 1;

                var sourceAmp,freqArray;
                sourceAmp = Amplitude.kr(input);
                freqArray = array;
                ^Mix.arFill ( freqArray.size, {arg i;
                        var source,  output, freq;
                        freq = freqArray.at(i);
                        output = CombN.ar(signal, 0.1, 1/freqArray.at(i),0.999,sourceAmp)*mull
                })
        }


}

